/*
    comp1
    
    This program is a syntactic analyzer for the following grammar:
    
       Expr::=  '(' oper Expr  Expr ')' | number
       oper ::= '+' | '-' 
       number ::= '0'| '1' | ... | '9'
     
    Example of program:
    
         (+ (- 5 4) 2)
*/

public class Compiler {

    public void compile( char []p_input ) {
        input = p_input;
        tokenPos = 0;
        nextToken();
        expr();
        if ( token != '\0' )
          error();
    }
    
    private void expr() {
        if ( token == '(' ) {
            nextToken();
            oper();
            expr();
            expr();
            if ( token == ')' ) 
              nextToken();
            else
              error();
        }
        else
          number();
    }
    
    private void number() {
        if ( token >= '0'  && token <= '9' ) {
            nextToken();
        }
        else
          error();
    }
    
    private void oper() {
        if ( token == '+' || token == '-' )
          nextToken();
        else
          error();
    }
    
    private void nextToken() {
        while (  tokenPos < input.length && input[tokenPos] == ' ' ) 
          tokenPos++;
        if ( tokenPos < input.length ) {
          token = input[tokenPos];        
          tokenPos++;
        }
        else
          token = '\0';
    }
    
    private void error() {
        if ( tokenPos == 0 ) 
          tokenPos = 1; 
        else 
          if ( tokenPos >= input.length )
            tokenPos = input.length;
        
        String strInput = new String( input, tokenPos - 1, input.length - tokenPos + 1 );
        String strError = "Error at \"" + strInput + "\"";
        System.out.println( strError );
        throw new RuntimeException(strError);
    }
    
    private char token;
    private int  tokenPos;
    private char []input;
      
}
