/*
    comp2
    
    This program is a syntactic analyzer and code generator for the following grammar:
    
       Expr::=  '(' oper Expr  Expr ')' | number
       oper ::= '+' | '-' 
       number ::= '0'| '1' | ... | '9'
       
     The code is generated to C.
     
*/

public class Compiler {

    public void compile( char []p_input ) {
        input = p_input;
        tokenPos = 0;
        nextToken();
        expr();
        if ( token != '\0')
          error();
    }
    
    private void expr() {
        if ( token == '(' ) {
            nextToken();
            char op = oper();
            System.out.print("(");
            expr();
            System.out.print(op);
            expr();
            System.out.print(")");
            if ( token == ')' ) 
              nextToken();
            else
              error();
        }
        else
          number();
    }
    
    private void number() {
        if ( token >= '0'  && token <= '9' ) {
            System.out.print(token);
            nextToken();
        }
        else
          error();
    }
    
    private char oper() {
        char op = token;
        if ( token == '+' || token == '-' ) {
          nextToken();
          return op;
        }
        else {
          error();
            // should never execute since error terminates the program
          return '\0';
        }
    }
    
    private void nextToken() {
        while (  tokenPos < input.length && input[tokenPos] == ' ' ) 
          tokenPos++;
        if ( tokenPos < input.length ) {
          token = input[tokenPos];        
          tokenPos++;
        }
        else
          token = '\0';
    }
    
    private void error() {
        if ( tokenPos == 0 ) 
          tokenPos = 1; 
        else 
          if ( tokenPos >= input.length )
            tokenPos = input.length;
        
        String strInput = new String( input, tokenPos - 1, input.length - tokenPos + 1 );
        String strError = "Error at \"" + strInput + "\"";
        System.out.print( strError );
           // throws an exception: terminate the program
        throw new RuntimeException(strError);
    }
    
    private char token;
    private int  tokenPos;
    private char []input;
    

        
}
    
    
    