/*
    comp3
    
    This program is a syntactic analyzer and code generator for the following grammar:
    
       Expr::=  '(' oper Expr  Expr ')' | number
       oper ::= '+' | '-' 
       number ::= '0'| '1' | ... | '9'
       
     The code is generated to ASM as described in Chapter 8 of the primer 
     "Construo de Compiladores". The generated code is as bad as anyone can ever design
     but it is enough to show how assembler code is produced.
     
*/

public class Compiler {

    public void compile( char []p_input ) {
        input = p_input;
        tokenPos = 0;
        nextToken();
        expr();
        if ( token != '\0' )
          error();
    }
    
    private void expr() {
        if ( token == '(' ) {
            nextToken();
            char op = oper();
            expr();
            expr();
            System.out.println("pop R1");
            System.out.println("pop R0");
            switch (op) {
                case '+' :
                  System.out.println("add R0, R1");
                  break;
                case '-' :
                  System.out.println("sub R0, R1");
                  break;
            }
            System.out.println("push R0");
            if ( token == ')' ) 
              nextToken();
            else
              error();
        }
        else
          number();
    }
    
    private void number() {
        if ( token >= '0'  && token <= '9' ) {
            System.out.println("mov R0, " + token );
            System.out.println("push R0");
            nextToken();
        }
        else
          error();
    }
    
    private char oper() {
        char op = token;
        if ( token == '+' || token == '-' ) {
          nextToken();
          return op;
        }
        else {
          error();
            // should never execute since error terminates the program
          return '\0';
        }
    }
    
    private void nextToken() {
        while (  tokenPos < input.length && input[tokenPos] == ' ' ) 
          tokenPos++;
        if ( tokenPos < input.length ) {
          token = input[tokenPos];        
          tokenPos++;
        }
        else
          token = '\0';
    }
    
    private void error() {
        if ( tokenPos == 0 ) 
          tokenPos = 1; 
        else 
          if ( tokenPos >= input.length )
            tokenPos = input.length;
        
        String strInput = new String( input, tokenPos - 1, input.length - tokenPos + 1 );
        String strError = "Error at \"" + strInput + "\"";
        System.out.print( strError );
        throw new RuntimeException(strError);
    }
    
    private char token;
    private int  tokenPos;
    private char []input;

}
    
    
    