import java_cup.runtime.*;
import java.lang.*;


%%

  // what to return at EOF ? Return symbol EOF
%eofval{
{
  return new Symbol(Sym.EOF, yychar, yychar + yylength(), null);
}
%eofval}       

%char
%line

  // the following three lines give the name Interface the generated class will implement,
  // the name of the method for getting the next token and the type of the tokens.
  // they can be replaced by "%cup"
%implements java_cup.runtime.Scanner
%function next_token
%type java_cup.runtime.Symbol
  // make class Lexer a public class
%public
  // the name of the generated class should be "Lexer"
%class Lexer

  // The symbols MINUS, PLUS, ... are declared in class Sym generated by CUP. See
  // option -symbols of CUP.
%%

"-"             { return new Symbol( Sym.MINUS, null ); }
"+"             { return new Symbol( Sym.PLUS, null ); }
"("             { return new Symbol( Sym.LEFTPAR, null ); }
")"             { return new Symbol( Sym.RIGHTPAR, null ); }
[0-9]           { return new Symbol( Sym.NUMBER, new Integer(yytext()) ); }


[ \t\r\n]       {}
. { System.out.println("unmatched: \"" + yytext() + "\"" + yyline); }

