import java_cup.runtime.*;

public class Main {

  public static void main(String argv[]) throws java.io.IOException {
    
      int i = 0;
      if ( argv.length < 1 ) {
        System.out.println("Program needs a parameter");
        return;
      }
        // input is from a file
      String filename = argv[0];
      java.io.InputStream inp = new java.io.FileInputStream(filename);
      Lexer lexer = new Lexer(inp);
      
      
        /* create a parsing object */
      Parser parser_obj = new Parser(lexer);

      try {
            // call the parser. The result will be an object Integer with the value
            // of the expression. Method parse returns the object Symbol returned by the
            // start production, which is Expr. The instance variable value of 
            // Symbol contains the value of the expression, which is an Integer
          System.out.println("Value = " + (Integer ) parser_obj.parse().value );
      } catch (Exception e) {
         System.out.println(e);
         e.printStackTrace();
      } 
  }
}



        