import java_cup.runtime.*;
import AST.*;

public class Main {

  public static void main(String argv[]) throws java.io.IOException {
    
      int i = 0;
      if ( argv.length < 1 ) {
        System.out.println("Program needs a parameter");
        return;
      }
        // input is from a file
      String filename = argv[0];
      java.io.InputStream inp = new java.io.FileInputStream(filename);
      Lexer lexer = new Lexer(inp);
      
      
        /* create a parsing object */
      Parser parser_obj = new Parser(lexer);

      try {
            // call the parser. The result will be an object Symbol whose instance
            // variable value points to an object with the AST, which is an Expr object
          Program p = (Program ) parser_obj.parse().value;
          p.genC();
      } catch (Exception e) {
         System.out.println(e);
         e.printStackTrace();
      } 
  }
}



        