package AST;

import CompilerRuntime;

public class CompositeExpr extends Expr {
    public CompositeExpr( Expr pleft, char poper, Expr pright ) {
        left = pleft;
        oper = poper;
        right = pright;
    }
    public void genC() {
        System.out.print("(");
        left.genC();
        System.out.print(" " + oper + " ");
        right.genC();
        System.out.print(")");
    }
    
    public int eval() {
        int evalLeft  = left.eval();
        int evalRight = right.eval();
        
        switch ( oper ) {
            case '+' :
              return evalLeft + evalRight;
            case '-' :
              return evalLeft - evalRight;
            case '*' :
              return evalLeft*evalRight;
            case '/' :
              if ( evalRight == 0 ) 
                CompilerRuntime.error("Division by zero");
              return evalLeft/evalRight;
            default : 
              CompilerRuntime.error("Unknown operator");
              return 0;
        }
    }
    
    private Expr left, right;
    private char oper;
}