package AST;

import Sym;

public class CompositeExpr extends Expr {
    public CompositeExpr( Expr pleft, int poper, Expr pright ) {
        left = pleft;
        oper = poper;
        right = pright;
    }
    public void genC() {
        System.out.print("(");
        left.genC();
        String s;
        switch (oper) {
            case Sym.PLUS : s = "+"; break;
            case Sym.MINUS : s = "-"; break;
            case Sym.MULT : s = "*"; break;
            case Sym.DIV : s = "/"; break;
            case Sym.GT  : s = ">"; break;
            case Sym.GE  : s = ">="; break;
            case Sym.LT  : s = "<"; break;
            case Sym.LE  : s = "<="; break;
            case Sym.EQ  : s = "=="; break;
            case Sym.NEQ : s = "!="; break;
            default :
              System.out.println("Internal compiler error: unknown operator");
              throw new RuntimeException();
        }
        System.out.print(" " + s + " ");
        right.genC();
        System.out.print(")");
    }
    
    private Expr left, right;
    private int oper;
};
